%define SPECIAL 	2132024h ; Special do uzytku wlasnego
%define ARG1		SPECIAL + 4
%define ARG2		SPECIAL + 8
%define TEMP1		SPECIAL + 12
%define TEMP2		SPECIAL + 16
%define SAVED_RET	SPECIAL + 20

[bits 32]

db 01			; Opcode 80h - pisanie pixelu na ekran o wspolrzednych podanych w argumencie (ARG1 - x, ARG2 - y) (oba argumenty to adres DWORD'a)
dd 02004000h
dd pixel

db 01
dd 02004014h	; Opcode 85h - odswiezanie ekranu. Nie przyjmuje argumentow
dd odswiez

db 1
dd SCR_KOLOR
dd 00FFFFFFh


db 0Eh
dd koniecEkran

pixel:

; Wrzucamy adres powrotu do SAVED_RET
db 02
dd SAVED_RET
dd 02000004h

; Przesuwamy adres powrotu o 9 bajtow (tyle zjmuje nasz opcode razem z argumentami)
db 03
dd SAVED_RET
dd 9

; Wrzucamy argumenty do ARG1 i ARG2
db 02			; [Mem] = [Mem] Bedziemy mieli return_addr pod SPECIAL
dd SPECIAL
dd 02000004h

db 3			; [Mem] += Imm AddMemImm Bedziemy mieli pod SPECIAL adres 1 argumentu
dd SPECIAL
dd 1


db 10h			; [Mem] = [[Mem]]
dd ARG1
dd SPECIAL


db 3			; [Mem] += Imm Bedziemy mieli w ARG2 2 argument
dd SPECIAL
dd 4

db 10h			; [Mem] = [[Mem]]
dd ARG2
dd SPECIAL
; Mamy argumenty


db 10h			; [Mem] = [[Mem]] Wartosc argumentu 1 do TEMP1
dd TEMP1
dd ARG1


db 10h			; [Mem] = [[Mem]] Wartosc argumentu 2 do TEMP2
dd TEMP2
dd ARG2


; Wyliczamy wspolrzedne pixela (02006000 + (x + y *640) * 4)

db 1
dd TEMP_MNOZ
dd 640

db 81h		; Mnozymy Y * 640
dd TEMP2
dd TEMP_MNOZ


db 04		; [Mem] += [Mem] (dodajemy x)
dd TEMP2
dd TEMP1


db 1
dd TEMP_MNOZ
dd 4

db 81h		; Mnozymy przez 4 (tyle bajtow zajmuje 1 pixel)
dd TEMP2
dd TEMP_MNOZ

db 03		; [Mem] += Imm (dodajemy 02006000, adres bufora ekranu)
dd TEMP2
dd 02006000h


;db 01		; Wsadzamy do TEMP2 wartosc 00FFFFFF (bialy pixel). Przyda sie w nastepnej instrukcji
;dd TEMP1
;dd 00FFFFFFh

db 11h		; [[Mem]] = [Mem]
dd TEMP2
dd SCR_KOLOR

; Pixel wsadzony, ekran odswiezamy osobnym opcodem

db 15h		; ReleaseInt

; Wracamy
db 0Dh
dd SAVED_RET

odswiez:
db 01
dd 02005000h
dd 1

db 02
dd SAVED_RET
dd 02000004h

db 03
dd SAVED_RET
dd 1

db 15h

db 0Dh
dd SAVED_RET

koniecEkran:
