%define SPECIAL 	2132050h ; Special do uzytku wlasnego
%define ARG1		SPECIAL + 4
;%define CURSORX		SPECIAL + 8
;%define CURSORY		SPECIAL + 12
%define TEMP1		SPECIAL + 16
%define TEMP2		SPECIAL + 20
%define SAVED_RET	SPECIAL + 28

%define IL_PETL		TEMP_POROW	; Dla kompatabilnosci

[bits 32]

db 1
dd CURSORX
dd 10

db 1
dd CURSORY
dd 10

db 01			; Opcode 83h - pisanie znaku podanego w argumencie w miejsce kursora - przyjmuje 1 argument, adres kodu ascii znaku
dd 0200400Ch
dd znak

db 1									; Opcode 91h - backspace o ilosc pixeli podanych w argumencie
dd 02004000h + ((91h - 80h) * 4)
dd opcode_backspace

db 0Eh
dd koniecFont

znak:

; Wrzucamy adres powrotu do SAVED_RET
db 02
dd SAVED_RET
dd 02000004h

; Przesuwamy adres powrotu o 5 bajtow (tyle zjmuje nasz opcode razem z argumentami)
db 03
dd SAVED_RET
dd 5

; Wrzucamy argument do ARG1
db 02			; [Mem] = [Mem] Bedziemy mieli return_addr pod SPECIAL
dd SPECIAL
dd 02000004h

db 3			; [Mem] += Imm AddMemImm Bedziemy mieli pod SPECIAL adres 1 argumentu
dd SPECIAL
dd 1

db 10h			; [Mem] = [[Mem]]
dd ARG1
dd SPECIAL

db 10h
dd ARG1
dd ARG1

; Mamy argument

	db 02
	dd TEMP1
	dd CURSORX

	db 02
	dd TEMP2
	dd CURSORY
	
	db 1		; Wszystkie tego wymagaja wiec zeby miejsca nie marnowac
	dd COUNTER
	dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		; Sprawdzamy czy to nie newline
		db 1
		dd TEMP_POROW
		dd 0Ah
		
		db 12h
		dd ascii_newline
		dd ARG1
		dd TEMP_POROW

		db 84h
		dd ARG1
		dd ' '
		
		; Mnozymy przez 4 (tablice mamy DWORDow)
		db 1
		dd TEMP_MNOZ
		dd 4
		
		db 81h
		dd ARG1
		dd TEMP_MNOZ
		
		; Dodajemy poczatek tablicy i juz mamy ladny wskaznik
		db 3
		dd ARG1
		dd adresy_liter
		
		db 10h
		dd ARG1
		dd ARG1
		
		db 0Dh
		dd ARG1
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	ascii_SPACE:
		db 3
		dd TEMP1
		dd 10
		
		db 0Eh
		dd poPtokach
	ascii_WYKRZ:
		%include "fonts/font_wykrz.asm"
		
		; Odejmujemy teraz CURSORX zeby nie bylo takiego duzego odstepu (na koncu opcodeu i tak bedzie CURSORX += 8)
		db 84h
		dd CURSORX
		dd 4
		
		db 0Eh
		dd poPtokach
	ascii_QUOT:
		db 0Eh
		dd poPtokach
	ascii_HASH:
		db 0Eh
		dd poPtokach
	ascii_DOLAR:
		db 0Eh
		dd poPtokach
	ascii_PERCENT:
		db 0Eh
		dd poPtokach
	ascii_AND:
		db 0Eh
		dd poPtokach
	ascii_SINQUOT:
		db 0Eh
		dd poPtokach
	ascii_BRACOPEN:
		db 0Eh
		dd poPtokach
	ascii_BRACCLOSE:
		db 0Eh
		dd poPtokach
	ascii_STAR:
		%include "fonts/font_star.asm"
		db 0Eh
		dd poPtokach
	ascii_PLUS:
		%include "fonts/font_plus.asm"
		db 0Eh
		dd poPtokach
	ascii_COMMA:
		%include "fonts/font_comma.asm"
		
		; Odejmujemy teraz CURSORX zeby nie bylo takiego duzego odstepu (na koncu opcodeu i tak bedzie CURSORX += 8)
		db 84h
		dd CURSORX
		dd 4
		
		db 0Eh
		dd poPtokach
	ascii_MINUS:
		%include "fonts/font_minus.asm"
		db 0Eh
		dd poPtokach
	ascii_DOT:
		%include "fonts/font_dot.asm"
		
		; Odejmujemy teraz CURSORX zeby nie bylo takiego duzego odstepu (na koncu opcodeu i tak bedzie CURSORX += 8)
		db 84h
		dd CURSORX
		dd 4
		
		db 0Eh
		dd poPtokach
	ascii_SLASH:
		%include "fonts/font_slash.asm"
		db 0Eh
		dd poPtokach
	
	; Cyferki
	ascii_0:
		%include "fonts/font_0.asm"
		db 0Eh
		dd poPtokach
	ascii_1:
		%include "fonts/font_1.asm"
		db 0Eh
		dd poPtokach
	ascii_2:
		%include "fonts/font_2.asm"
		db 0Eh
		dd poPtokach
	ascii_3:
		%include "fonts/font_3.asm"
		db 0Eh
		dd poPtokach
	ascii_4:
		%include "fonts/font_4.asm"
		db 0Eh
		dd poPtokach
	ascii_5:
		%include "fonts/font_5.asm"
		db 0Eh
		dd poPtokach
	ascii_6:
		%include "fonts/font_6.asm"
		db 0Eh
		dd poPtokach
	ascii_7:
		%include "fonts/font_7.asm"
		db 0Eh
		dd poPtokach
	ascii_8:
		%include "fonts/font_8.asm"
		db 0Eh
		dd poPtokach
	ascii_9:
		%include "fonts/font_9.asm"
		db 0Eh
		dd poPtokach
	
	
	ascii_COLON:
		%include "fonts/font_colon.asm"
		
		; Odejmujemy teraz CURSORX zeby nie bylo takiego duzego odstepu (na koncu opcodeu i tak bedzie CURSORX += 8)
		db 84h
		dd CURSORX
		dd 4
		
		db 0Eh
		dd poPtokach
	ascii_SEMICOL:
		db 0Eh
		dd poPtokach
	ascii_LESS:
		db 0Eh
		dd poPtokach
	ascii_EQUAL:
		%include "fonts/font_equal.asm"
		db 0Eh
		dd poPtokach
	ascii_MORE:
		%include "fonts/font_more.asm"
		db 0Eh
		dd poPtokach
	ascii_QUEST:
		%include "fonts/font_pyt.asm"
		db 0Eh
		dd poPtokach
	ascii_AT:
		%include "fonts/font_at.asm"
		db 0Eh
		dd poPtokach
		
		
	; Literki
	ascii_A:
		%include "fonts/font_a.asm"
		db 0Eh
		dd poPtokach
	ascii_B:
		%include "fonts/font_b.asm"
		db 0Eh
		dd poPtokach
	ascii_C:
		%include "fonts/font_c.asm"
		db 0Eh
		dd poPtokach
	ascii_D:
		%include "fonts/font_d.asm"
		db 0Eh
		dd poPtokach
	ascii_E:
		%include "fonts/font_e.asm"
		db 0Eh
		dd poPtokach
	ascii_F:
		%include "fonts/font_f.asm"
		db 0Eh
		dd poPtokach
	ascii_G:
		%include "fonts/font_g.asm"
		db 0Eh
		dd poPtokach
	ascii_H:
		%include "fonts/font_h.asm"
		db 0Eh
		dd poPtokach
	ascii_I:
		%include "fonts/font_i.asm"
		db 0Eh
		dd poPtokach
	ascii_J:
		%include "fonts/font_j.asm"
		db 0Eh
		dd poPtokach
	ascii_K:
		%include "fonts/font_k.asm"
		db 0Eh
		dd poPtokach
	ascii_L:
		%include "fonts/font_l.asm"
		db 0Eh
		dd poPtokach
	ascii_M:
		%include "fonts/font_m.asm"
		db 0Eh
		dd poPtokach
	ascii_N:
		%include "fonts/font_n.asm"
		db 0Eh
		dd poPtokach
	ascii_O:
		%include "fonts/font_o.asm"
		db 0Eh
		dd poPtokach
	ascii_P:
		%include "fonts/font_p.asm"
		db 0Eh
		dd poPtokach
	ascii_Q:
		%include "fonts/font_q.asm"
		db 0Eh
		dd poPtokach
	ascii_R:
		%include "fonts/font_r.asm"
		db 0Eh
		dd poPtokach
	ascii_S:
		%include "fonts/font_s.asm"
		db 0Eh
		dd poPtokach
	ascii_T:
		%include "fonts/font_t.asm"
		db 0Eh
		dd poPtokach
	ascii_U:
		%include "fonts/font_u.asm"
		db 0Eh
		dd poPtokach
	ascii_V:
		%include "fonts/font_v.asm"
		db 0Eh
		dd poPtokach
	ascii_W:
		%include "fonts/font_w.asm"
		db 0Eh
		dd poPtokach
	ascii_X:
		%include "fonts/font_x.asm"
		db 0Eh
		dd poPtokach
	ascii_Y:
		%include "fonts/font_y.asm"
		db 0Eh
		dd poPtokach
	ascii_Z:
		%include "fonts/font_z.asm"
		db 0Eh
		dd poPtokach
	
	
	ascii_SBRACKETOPEN:
		db 0Eh
		dd poPtokach
	ascii_BACKSLASH:
		db 0Eh
		dd poPtokach
	ascii_SBRACKETCLOSE:
		db 0Eh
		dd poPtokach
	ascii_POWER:
		db 0Eh
		dd poPtokach
	ascii_UNDERLINE:
		db 0Eh
		dd poPtokach
	ascii_PTASZEK:
		db 0Eh
		dd poPtokach
	
	ascii_CLAMBRACOPEN:
		db 0Eh
		dd poPtokach
	ascii_PIPE:
		db 0Eh
		dd poPtokach
	ascii_CLAMBRACLOSE:
		db 0Eh
		dd poPtokach
	ascii_TILDA:
		db 0Eh
		dd poPtokach
	
	
	poPtokach:
	db 1
	dd TEMP1
	dd 622
	
	db 13h
	dd ascii_newline
	dd TEMP1
	dd CURSORX
	
	db 0Eh
	dd koniec_ascii_newline
	
	ascii_newline:
		db 1
		dd CURSORX
		dd 2		; Potem dodamy 8 wiec bedzie 10
		
		
		db 1
		dd TEMP_POROW
		dd 470
		
		db 13h
		dd wstaw_normalny_newline
		dd CURSORY
		dd TEMP_POROW

		
		; Tutaj jestesmy pod koniec ekranu, czyli CURSORY zostaje jak jest a my sidmem przenosimy ekranik do gory

		db 1
		dd TEMP_POROW
		dd 640 * 469					; W TEMP_POROW ilosc DWORDOW do skopiowania, linijka zajmuje 7 bjatow (literka) + 2 bajty (margines) = 9 bajtow
		
		db 16h							; SIMDMove_MemMemMem
		dd 02006000h + (10 * 640 * 4)	; Wrzucamy na poczatek ekranu ofc
		dd 02006000h + (20 * 640 * 4)	; Poczatek drugiej linijki
		dd TEMP_POROW
		
		db 1
		dd TEMP_POROW
		dd 640 * 10
		
		db 23h				; SIMDSet_MemImmMem
		dd 02006000h + (640 * 47 * 10 * 4)
		dd 0
		dd TEMP_POROW
		
		db 0Eh
		dd koniec_ascii_newline
		
		
		
		wstaw_normalny_newline:
			db 3
			dd CURSORY
			dd 10
	
	koniec_ascii_newline:
	
	db 3
	dd CURSORX
	dd 8

db 85h	; Odswiezamy ekran

db 15h		; ReleaseInt

; Wracamy
db 0Dh
dd SAVED_RET

adresy_liter:
dd ascii_SPACE
dd ascii_WYKRZ
dd ascii_QUOT
dd ascii_HASH
dd ascii_DOLAR
dd ascii_PERCENT
dd ascii_AND
dd ascii_SINQUOT
dd ascii_BRACOPEN
dd ascii_BRACCLOSE
dd ascii_STAR
dd ascii_PLUS
dd ascii_COMMA
dd ascii_MINUS
dd ascii_DOT
dd ascii_SLASH

dd ascii_0
dd ascii_1
dd ascii_2
dd ascii_3
dd ascii_4
dd ascii_5
dd ascii_6
dd ascii_7
dd ascii_8
dd ascii_9

dd ascii_COLON
dd ascii_SEMICOL
dd ascii_LESS
dd ascii_EQUAL
dd ascii_MORE
dd ascii_QUEST
dd ascii_AT

dd ascii_A
dd ascii_B
dd ascii_C
dd ascii_D
dd ascii_E
dd ascii_F
dd ascii_G
dd ascii_H
dd ascii_I
dd ascii_J
dd ascii_K
dd ascii_L
dd ascii_M
dd ascii_N
dd ascii_O
dd ascii_P
dd ascii_Q
dd ascii_R
dd ascii_S
dd ascii_T
dd ascii_U
dd ascii_V
dd ascii_W
dd ascii_X
dd ascii_Y
dd ascii_Z

dd ascii_SBRACKETOPEN
dd ascii_BACKSLASH
dd ascii_SBRACKETCLOSE
dd ascii_POWER			; Hoifi jak to sie nazywa?
dd ascii_UNDERLINE
dd ascii_PTASZEK		; A to?

dd ascii_A
dd ascii_B
dd ascii_C
dd ascii_D
dd ascii_E
dd ascii_F
dd ascii_G
dd ascii_H
dd ascii_I
dd ascii_J
dd ascii_K
dd ascii_L
dd ascii_M
dd ascii_N
dd ascii_O
dd ascii_P
dd ascii_Q
dd ascii_R
dd ascii_S
dd ascii_T
dd ascii_U
dd ascii_V
dd ascii_W
dd ascii_X
dd ascii_Y
dd ascii_Z

dd ascii_CLAMBRACOPEN
dd ascii_PIPE
dd ascii_CLAMBRACLOSE
dd ascii_TILDA

; ------------------------------------------------------------------------------------------------------- tutaj zaczyna sie opcode backspace ------------------------------------------------------------------------------------------------------------------------------------------

opcode_backspace:
; Wrzucamy adres powrotu do SAVED_RET
db 02
dd SAVED_RET
dd 02000004h



; Przesuwamy adres powrotu o 5 bajtow (tyle zjmuje nasz opcode razem z argumentami)
db 03
dd SAVED_RET
dd 5

; Wrzucamy argument do ARG1
db 02			; [Mem] = [Mem] Bedziemy mieli return_addr pod SPECIAL
dd SPECIAL
dd 02000004h

db 3			; [Mem] += Imm AddMemImm Bedziemy mieli pod SPECIAL adres 1 argumentu
dd SPECIAL
dd 1

db 10h			; [Mem] = [[Mem]]
dd ARG1
dd SPECIAL

; Mamy argument gdzie trzeba

db 87h
dd CURSORX
dd ARG1

db 1
dd TEMP_MNOZ
dd 640

db 2
dd TEMP2
dd CURSORY

db 2
dd TEMP1
dd CURSORX

db 81h		; Mnozymy Y * 640
dd TEMP2
dd TEMP_MNOZ


db 04		; [Mem] += [Mem] (dodajemy x)
dd TEMP2
dd TEMP1


db 1
dd TEMP_MNOZ
dd 4

db 81h		; Mnozymy przez 4 (tyle bajtow zajmuje 1 pixel)
dd TEMP2
dd TEMP_MNOZ

db 03		; [Mem] += Imm (dodajemy 02006000, adres bufora ekranu)
dd TEMP2
dd 02006000h

; Czyscimy nasze pole

db 1
dd COUNTER
dd 0

db 1
dd TEMP_POROW
dd 7

db 1
dd TEMP_ODEJM
dd 4

db 81h
dd TEMP_ODEJM
dd ARG1

petla_czysc:
db 1
dd COUNTER2
dd 0

db 2
dd TEMP_POROW2
dd ARG1
	petla_czysc2:
		db 1
		dd TEMP1	; Bo TEMP_POROW mamy zajete ;/
		dd 0
		
		db 11h			; Wsadzamy 0 do [[Temp2]]
		dd TEMP2
		dd TEMP1
		
		db 3
		dd COUNTER2
		dd 1
		
		db 3
		dd TEMP2
		dd 4
		
		db 13h
		dd petla_czysc2
		dd COUNTER2
		dd TEMP_POROW2

db 87h
dd TEMP2
dd TEMP_ODEJM
	
db 3
dd TEMP2
dd 640*4

db 3
dd COUNTER
dd 1

db 13h
dd petla_czysc
dd COUNTER
dd TEMP_POROW

db 85h

koniec_opcode_backspace:

db 15h

db 0Dh
dd SAVED_RET


koniecFont:
