; Male wyjasnienie:
; Pod klawiature bedziemy mieli przypisany 1 opcode ktory nam wczyta linijke z klawiatury
; - wsadzi do adresu z handlerem klawiatury adres obslugujacy nacisniecie klawisza (no i wyprintowanie go na ekran)
; - handler ten bedzie wsadzal swoj wynik na odpowiedni adres
; - jesli natrafi na newline do handlera pojdzie NULL (czyli nie beda przechwytywane nasze klawisze)
; - nasza funkcja z opcodeu bedzie sobie sprawdzac ten adres i w przypadku nulla wroci tam skad zostala wywolana i bedziemy mogli sobie odczytac

%define SAVED_RET 			01FF0000h
%define SAVED_RET_OPCODE	SAVED_RET + 4
%define BUFFER_PTR			SAVED_RET + 8		; Pozycja w buforze klawiatury
%define TEMP_BACKSPACE		SAVED_RET + 12

[BITS 32]

db 1
dd 02004000h + ((95h - 80h) * 4)
dd opcode_gets

db 0Eh
dd klawiaturaKoniec

opcode_gets:
	; Zapamietujemy RET_ADDR
	db 2
	dd SAVED_RET_OPCODE
	dd 02000004h
	
	db 3
	dd SAVED_RET_OPCODE
	dd 1
	
	; Zerujemy wskaznik
	db 1
	dd BUFFER_PTR
	dd KEYBOARD_RETURN
	
	db 15h	; Musimy teraz zwolnic przerwania zeby nam sie keyboardHandler wywolywal
	
	; Przypisujemy pod zdarzenie nacisniecia klawisza funkcje keyboardHandler
	db 1
	dd 02002004h
	dd keyboardHandler

	
	petla_czekaj_klawiatura:
	db 1
	dd TEMP_POROW
	dd 0
	
	db 12h
	dd koniec_petli_czekaj_klawiatura
	dd 02002004h
	dd TEMP_POROW

	db 0Eh
	dd petla_czekaj_klawiatura
	
	koniec_petli_czekaj_klawiatura:
	; Nacisniety zostal ENTER wiec wracamy
	
	db 0Dh
	dd SAVED_RET_OPCODE
; KONIEC OPCODEU KLAWIATURY ----------------------------------------------------------------------------------------------
	
	keyboardHandler:
		db 2
		dd SAVED_RET
		dd 02000004h
	
	
		; Sprawdzamy czy zostal nacisniety znak ascii
		db 1
		dd TEMP_POROW
		dd ' '-1
	
		db 13h
		dd sprawdz_ascii_etap_2
		dd TEMP_POROW
		dd 02002008h			; Key Handler
	
		db 0Eh
		dd koniec_ascii
	
		sprawdz_ascii_etap_2:
	
		db 1
		dd TEMP_POROW
		dd 'z' + 1
	
		db 13h
		dd sprawdz_shift
		dd 02002008h			; Key Handler
		dd TEMP_POROW
	
		db 0Eh
		dd koniec_ascii
		
		sprawdz_shift:
		db 1
		dd TEMP_POROW
		dd 1
		
		; Sprawdzamy czy zostal nacisniety LSHIFT (303) albo RSHIFT (304)
		db 12h
		dd wstaw_znak_z_shift
		dd TEMP_POROW
		dd 02002010h + (303 * 4)
		
		db 12h
		dd wstaw_znak_z_shift
		dd TEMP_POROW
		dd 02002010h + (304 * 4)
		
		; Jesli nie zostal nacisniety to po prostu rysujemy literke
		db 0Eh
		dd pisz_literke
		
		wstaw_znak_z_shift:
		db 84h
		dd 02002008h
		dd ' '
		
		db 3
		dd 02002008h
		dd keymap_shift
		
		db 10h
		dd 02002008h
		dd 02002008h
		
		db 5
		dd 02002008h
		dd 0FFh
		
	
		pisz_literke:
		; Wypisujemy literke na ekran
		db 83h
		dd 02002008h
		db 85h
		
		; Wsadzamy litekre do bufora i go przesuwamy
		db 11h
		dd BUFFER_PTR
		dd 02002008h
		
		
		db 3
		dd BUFFER_PTR
		dd 1
	
	
		db 0Eh
		dd koniec_klawiatura
		
		koniec_ascii:
	
		; Sprawdzamy poszczegolne klawisze
		; Enter
		db 1
		dd TEMP_POROW
		dd 13
	
		db 12h
		dd keyboard_newline
		dd 02002008h
		dd TEMP_POROW
		
		db 1
		dd TEMP_POROW
		dd 8
		
		db 12h
		dd keyboard_backspace
		dd 02002008h
		dd TEMP_POROW
	
		; NASTEPNY KLAWISZ
		; ......
	
		db 0Eh
		dd koniec_klawiatura
		
		; Tutaj funkcje dotyczace nacisniecia poszczegolnych klawiszy
		; Enter
		; Jesli enter to wsadzamy 0 do 02000004h i konczymy cala funkcje
		
		keyboard_newline:
		db 1
		dd 02002004h
		dd 0
		
		db 1
		dd TEMP_ZNAK
		dd 0Ah
		
		db 83h
		dd TEMP_ZNAK
		db 85h
		
		; Nullbajt do wskaznika
		db 1
		dd TEMP_ZNAK
		dd 0
		
		db 11h
		dd BUFFER_PTR
		dd TEMP_ZNAK
		
		db 0Eh
		dd koniec_klawiatura
		
		keyboard_backspace:
		
		; Najpierw sprawdzmy czy KEYBOARD_RETURN == *BUFFER_PTR (czyli nie wpisalismy nic)
		db 1
		dd TEMP_POROW
		dd KEYBOARD_RETURN
		
		db 12h
		dd koniec_klawiatura
		dd TEMP_POROW
		dd BUFFER_PTR
		
		db 2
		dd TEMP_BACKSPACE
		dd BUFFER_PTR
		
		; Odejmujemy 1 od BUFFER_PTR. Czyli ten backspace wlasciwy :P
		db 84h
		dd BUFFER_PTR
		dd 1
		
		db 84h
		dd TEMP_BACKSPACE
		dd 1
		
		db 10h
		dd TEMP_BACKSPACE
		dd TEMP_BACKSPACE
		
		; Ucinamy niepotrzebne bajty
		db 5
		dd TEMP_BACKSPACE
		dd 0FFh
		
		; Teraz pod TEMP_BACKSPACE mamy kod ascii naszego klawisza
		
		db 1
		dd TEMP_POROW
		dd '.'
		
		db 12h
		dd wstaw_krotki_backspace
		dd TEMP_POROW
		dd TEMP_BACKSPACE
		
		db 1
		dd TEMP_POROW
		dd '!'
		
		db 12h
		dd wstaw_krotki_backspace
		dd TEMP_POROW
		dd TEMP_BACKSPACE
		
		db 1
		dd TEMP_POROW
		dd ':'
		
		db 12h
		dd wstaw_krotki_backspace
		dd TEMP_POROW
		dd TEMP_BACKSPACE
		
		db 1
		dd TEMP_POROW
		dd ','
		
		db 12h
		dd wstaw_krotki_backspace
		dd TEMP_POROW
		dd TEMP_BACKSPACE
		
		db 1
		dd TEMP_POROW
		dd ';'
		
		db 12h
		dd wstaw_krotki_backspace
		dd TEMP_POROW
		dd TEMP_BACKSPACE
		
		wstaw_dlugi_backspace:	; Cofamy sie o 8 pixeli (zeby wymazac np. litere)
		
		db 91h
		dd 8
		
		
		db 0Eh
		dd koniec_klawiatura
		
		wstaw_krotki_backspace:	; Cofamy sie o 4 pixele (zeby wymazac kropke, wykrzyknik itd.)
		
		db 91h
		dd 4
		

		db 0Eh
		dd koniec_klawiatura
	
		koniec_klawiatura:
	
		db 15h	; ReleaseInt

	
		db 0Dh
		dd SAVED_RET

	keymap_shift:
	db ' '
	times 6 db 0
	db '"'
	times 4 db 0
	db '<'
	db '_'
	db '>'
	db '?'
	db ')'
	db '!'
	db '@'
	db '#'
	db '$'
	db '%'
	db '^'
	db '&'
	db '*'
	db '('
	db 0
	db ':'
	db 0
	db '+'
	times 29 db 0
	db '{'
	db '|'
	times 3 db 0
	db '~'
	db 'a'
	db 'b'
	db 'c'
	db 'd'
	db 'e'
	db 'f'
	db 'g'
	db 'h'
	db 'i'
	db 'j'
	db 'k'
	db 'l'
	db 'm'
	db 'n'
	db 'o'
	db 'p'
	db 'q'
	db 'r'
	db 's'
	db 't'
	db 'u'
	db 'v'
	db 'w'
	db 'x'
	db 'y'
	db 'z'
	times 4 db 0
		
klawiaturaKoniec: