%define SPECIAL					2150000h
%define SAVED_RET_MEM			SPECIAL + 4
%define SAVED_RET_IMM			SPECIAL + 8
%define ARG1_MEM				SPECIAL + 12
%define ARG2_MEM				SPECIAL + 16
%define ARG1_IMM				SPECIAL + 20
%define ARG2_IMM				SPECIAL + 24
%define TEMP_IMM				SPECIAL + 28	; TEMP potrzebny do 84h
%define TEMP_POROW_ODEJM		SPECIAL + 32
[bits 32]

; Setup own opcode
db 1          
dd 02004000h + ((84h - 80h) * 4)
dd substractImm

db 1
dd 02004000h + ((87h - 80h) * 4)
dd substractMem

db 0Eh
dd koniecOdejmowanie



substractImm:
; Wrzucamy adres powrotu do SAVED_RET
db 02
dd SAVED_RET_IMM
dd 02000004h

; Przesuwamy adres powrotu o 9 bajtow (tyle zjmuje nasz opcode razem z argumentami)
db 03
dd SAVED_RET_IMM
dd 9

; Wrzucamy argumenty do ARG1 i ARG2
db 02			; [Mem] = [Mem] Bedziemy mieli return_addr pod SPECIAL
dd SPECIAL
dd 02000004h

db 3			; [Mem] += Imm AddMemImm Bedziemy mieli pod SPECIAL adres 1 argumentu
dd SPECIAL
dd 1


db 10h			; [Mem] = [[Mem]]
dd ARG1_IMM
dd SPECIAL


db 3			; [Mem] += Imm Bedziemy mieli w ARG2 2 argument
dd SPECIAL
dd 4

db 10h			; [Mem] = [[Mem]]
dd ARG2_IMM
dd SPECIAL
; Mamy argumenty

db 10h
dd TEMP_IMM
dd ARG1_IMM

db 87h
dd TEMP_IMM
dd ARG2_IMM

db 11h
dd ARG1_IMM
dd TEMP_IMM

db 15h

db 0Dh
dd SAVED_RET_IMM


substractMem:
; Wrzucamy adres powrotu do SAVED_RET
db 02
dd SAVED_RET_MEM
dd 02000004h

; Przesuwamy adres powrotu o 9 bajtow (tyle zjmuje nasz opcode razem z argumentami)
db 03
dd SAVED_RET_MEM
dd 9

; Wrzucamy argumenty do ARG1 i ARG2
db 02			; [Mem] = [Mem] Bedziemy mieli return_addr pod SPECIAL
dd SPECIAL
dd 02000004h

db 3			; [Mem] += Imm AddMemImm Bedziemy mieli pod SPECIAL adres 1 argumentu
dd SPECIAL
dd 1


db 10h			; [Mem] = [[Mem]]
dd ARG1_MEM
dd SPECIAL


db 3			; [Mem] += Imm Bedziemy mieli w ARG2 2 argument
dd SPECIAL
dd 4

db 10h			; [Mem] = [[Mem]]
dd ARG2_MEM
dd SPECIAL

db 10h
dd ARG2_MEM
dd ARG2_MEM
; Mamy argumenty

db 0Fh		; Neg Mem
dd ARG2_MEM

db 3
dd ARG2_MEM
dd 1

db 10h
dd TEMP_POROW_ODEJM
dd ARG1_MEM

db 4
dd TEMP_POROW_ODEJM
dd ARG2_MEM

db 11h
dd ARG1_MEM
dd TEMP_POROW_ODEJM

db 15h

db 0Dh
dd SAVED_RET_MEM
koniecOdejmowanie: