%define WAZ_GLOWA_X				BASE_RAM + 80
%define WAZ_GLOWA_Y				BASE_RAM + 84
%define WAZ_DUPA_X				BASE_RAM + 88
%define WAZ_DUPA_Y				BASE_RAM + 92
%define WAZ_KIERUNEK			BASE_RAM + 96
%define TEMP_POLE				BASE_RAM + 100
%define WPISANY_KIER			BASE_RAM + 104	; Trudna do opisania sytuacja, kiedy zmienimy kierunek zanim zdazy sie zapisac w planszy
%define JEDZONKO_X				BASE_RAM + 108
%define JEDZONKO_Y				BASE_RAM + 112
%define SAVED_RET				BASE_RAM + 116	; Do hdlera klawiaturki
%define VAR_ZEBRANO_JEDZONKO	BASE_RAM + 120
%define PUNKTY					BASE_RAM + 124
%define KOLKO_WAZ_WYS			waz_kolko
%define KOLKO_WAZ_SZER			waz_kolko + 4
%define JEDZONKO_WYS			jedzonko
%define JEDZONKO_SZER			jedzonko + 4
%define PLANSZA					BASE_RAM + 130 ; tablica DWORDOW [32][47] (6016 bajtow)

%define PLANSZA_WIDTH	42
%define PLANSZA_HEIGHT	32

%define JABUSZKO		1
%define KIERUNEK_GORA	2
%define KIERUNEK_DOL	3
%define KIERUNEK_LEWO	4
%define KIERUNEK_PRAWO	5

%define WAZ_POCZATEK_X 			PLANSZA_WIDTH / 2
%define WAZ_POCZATEK_Y 			PLANSZA_HEIGHT / 2
%define WAZ_POCZATEK_DLUGOSC	4

[bits 32]

db 1
dd TEMP_POROW
dd 640*480

db 23h
dd 02006000h
dd 0
dd TEMP_POROW

db 1
dd TEMP_POROW
dd PLANSZA_WIDTH * PLANSZA_HEIGHT

db 23h
dd PLANSZA
dd 0
dd TEMP_POROW

; Rysujemy poczatek weza i ustawiamy WAZ_GLOWA i WAZ_DUPA

db 1
dd WAZ_GLOWA_X
dd WAZ_POCZATEK_X

db 1
dd WAZ_GLOWA_Y
dd WAZ_POCZATEK_Y

db 1
dd WAZ_DUPA_X
dd WAZ_POCZATEK_X - WAZ_POCZATEK_DLUGOSC + 1 ; (sic!)

db 2
dd WAZ_DUPA_Y
dd WAZ_GLOWA_Y

db 1
dd WAZ_KIERUNEK
dd KIERUNEK_PRAWO

; Ustawmy odbicie weza na planszy
db 2
dd TEMP_POROW
dd WAZ_GLOWA_Y

db 1
dd TEMP_MNOZ
dd PLANSZA_WIDTH * 4

db 81h
dd TEMP_POROW
dd TEMP_MNOZ

db 2
dd TEMP_POROW2
dd WAZ_GLOWA_X

db 0Bh	; Shl MemImm
dd TEMP_POROW2
dd 2

db 4
dd TEMP_POROW
dd TEMP_POROW2

db 3
dd TEMP_POROW
dd PLANSZA

db 1
dd COUNTER
dd 0

db 1
dd TEMP_POROW2
dd WAZ_POCZATEK_DLUGOSC

; Musimy miec pod jakims adresem (11h: [[mem]] = [mem])
db 1
dd TEMP_DZIEL
dd KIERUNEK_PRAWO
waz_petla_ustaw_plansze_poczatek:
	db 11h
	dd TEMP_POROW
	dd TEMP_DZIEL

	db 84h
	dd TEMP_POROW
	dd 4

	db 3
	dd COUNTER
	dd 1

	db 13h
	dd waz_petla_ustaw_plansze_poczatek
	dd COUNTER
	dd TEMP_POROW2


; Wszystko ustawione, teraz narysujemy poczatek weza
db 2
dd CURSORX
dd WAZ_GLOWA_X
	
db 2
dd CURSORY
dd WAZ_GLOWA_Y
	
db 2
dd TEMP_MNOZ
dd KOLKO_WAZ_SZER
	
db 81h
dd CURSORX
dd TEMP_MNOZ
	
db 2
dd TEMP_MNOZ
dd KOLKO_WAZ_WYS

db 81h
dd CURSORY
dd TEMP_MNOZ

db 1
dd COUNTER
dd 0

db 1
dd TEMP_POROW
dd WAZ_POCZATEK_DLUGOSC

petla_rysuj_poczatek_weza:
	db 8Eh
	dd waz_kolko
	dd CURSORX
	dd CURSORY
	
	db 87h
	dd CURSORX
	dd KOLKO_WAZ_SZER
	
	db 3
	dd COUNTER
	dd 1
	
	db 13h
	dd petla_rysuj_poczatek_weza
	dd COUNTER
	dd TEMP_POROW

; Ustawiamy klawiaturke
db 1
dd 02002004h
dd snake_keyboard_handler

db 1
dd WPISANY_KIER
dd 0

db 1
dd TEMP_SLEEP
dd 100

db 1
dd PUNKTY
dd 0

; Ustawiamy jedzonko
db 2
dd JEDZONKO_X
dd 02000010h

db 1
dd TEMP_MNOZ
dd PLANSZA_WIDTH

; Modulo zeby sie zmiescilo wszystko ladnie na planszy
db 89h
dd JEDZONKO_X
dd TEMP_MNOZ

db 2
dd JEDZONKO_Y
dd 02000010h

db 1
dd TEMP_MNOZ
dd PLANSZA_HEIGHT

db 89h
dd JEDZONKO_Y
dd TEMP_MNOZ

; Mamy wspolrzedne w JEDZONKO_X i JEDZONKO_Y, teraz rysujemy na ekranie

db 2
dd CURSORX
dd JEDZONKO_X

db 2
dd CURSORY
dd JEDZONKO_Y

db 81h
dd CURSORX
dd JEDZONKO_SZER

db 81h
dd CURSORY
dd JEDZONKO_WYS

db 8Eh
dd jedzonko
dd CURSORX
dd CURSORY

; Narysowane, teraz zaznaczamy na planszy
db 1
dd TEMP_MNOZ
dd PLANSZA_WIDTH * 4

db 81h
dd JEDZONKO_Y
dd TEMP_MNOZ

db 0Bh
dd JEDZONKO_X
dd 2

db 4
dd JEDZONKO_Y
dd JEDZONKO_X

db 3
dd JEDZONKO_Y
dd PLANSZA

db 1
dd TEMP_POROW
dd JABUSZKO

db 11h
dd JEDZONKO_Y
dd TEMP_POROW

snake_main_loop:
	db 99h
	dd TEMP_SLEEP
	
	db 1
	dd VAR_ZEBRANO_JEDZONKO
	dd 0
	
	db 2
	dd TEMP_POROW
	dd WAZ_KIERUNEK
	
	db 1
	dd TEMP_MNOZ
	dd 4
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 3
	dd TEMP_POROW
	dd tablica_skokow_glowa
	
	db 10h
	dd TEMP_POROW
	dd TEMP_POROW
	
	db 0Dh
	dd TEMP_POROW
	
	tablica_skokow_glowa:
	dd 0
	dd 0
	dd snake_przesun_gora
	dd snake_przesun_dol
	dd snake_przesun_lewo
	dd snake_przesun_prawo
	
	snake_przesun_gora:
		db 84h
		dd WAZ_GLOWA_Y
		dd 1
	
		db 0Eh
		dd po_przesunieciu
	snake_przesun_dol:
		db 3
		dd WAZ_GLOWA_Y
		dd 1
	
		db 0Eh
		dd po_przesunieciu
	snake_przesun_lewo:
		db 84h
		dd WAZ_GLOWA_X
		dd 1
	
		db 0Eh
		dd po_przesunieciu
	snake_przesun_prawo:
		db 3
		dd WAZ_GLOWA_X
		dd 1
	
		db 0Eh
		dd po_przesunieciu
	
	po_przesunieciu:
	
	; Sprawdzamy kolizje
	db 2
	dd TEMP_POROW
	dd WAZ_GLOWA_Y
	
	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH * 4
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 2
	dd TEMP_POROW2
	dd WAZ_GLOWA_X
	
	db 0Bh
	dd TEMP_POROW2
	dd 2
	
	db 4
	dd TEMP_POROW
	dd TEMP_POROW2
	
	db 3
	dd TEMP_POROW
	dd PLANSZA
	
	db 10h
	dd TEMP_POLE
	dd TEMP_POROW
	
	db 1
	dd TEMP_POROW
	dd 1
	
	; Czy zderzylismy sie z wezem
	db 13h
	dd snake_lose
	dd TEMP_POROW
	dd TEMP_POLE
	
	; Czy zjedlismy AM AM
	db 12h
	dd zebrano_jedzonko
	dd TEMP_POROW
	dd TEMP_POLE
	
	db 0Eh
	dd po_zebraniu_jedzonka
	
	zebrano_jedzonko:
	; Losujemy i rysujemy nowe zarcie
	; Ustawiamy jedzonko (tak, to jest kopia tego z gory)
	db 2
	dd JEDZONKO_X
	dd 02000010h

	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH

	; Modulo zeby sie zmiescilo wszystko ladnie na planszy
	db 89h
	dd JEDZONKO_X
	dd TEMP_MNOZ

	db 2
	dd JEDZONKO_Y
	dd 02000010h

	db 1
	dd TEMP_MNOZ
	dd PLANSZA_HEIGHT

	db 89h
	dd JEDZONKO_Y
	dd TEMP_MNOZ

	; Mamy wspolrzedne w JEDZONKO_X i JEDZONKO_Y, teraz rysujemy na ekranie

	db 2
	dd CURSORX
	dd JEDZONKO_X

	db 2
	dd CURSORY
	dd JEDZONKO_Y

	db 81h
	dd CURSORX
	dd JEDZONKO_SZER

	db 81h
	dd CURSORY
	dd JEDZONKO_WYS

	db 8Eh
	dd jedzonko
	dd CURSORX
	dd CURSORY

	; Narysowane, teraz zaznaczamy na planszy
	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH * 4

	db 81h
	dd JEDZONKO_Y
	dd TEMP_MNOZ

	db 0Bh
	dd JEDZONKO_X
	dd 2

	db 4
	dd JEDZONKO_Y
	dd JEDZONKO_X

	db 3
	dd JEDZONKO_Y
	dd PLANSZA

	db 1
	dd TEMP_POROW
	dd JABUSZKO

	db 11h
	dd JEDZONKO_Y
	dd TEMP_POROW
	
	db 1
	dd VAR_ZEBRANO_JEDZONKO
	dd 1
	
	db 3
	dd PUNKTY
	dd 1
	
	po_zebraniu_jedzonka:
	; Po sprawdzeniu kolizji
	
	; Oznaczamy nowa glowe na planszy
	db 2
	dd TEMP_POROW
	dd WAZ_GLOWA_Y
	
	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH * 4
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 2
	dd TEMP_POROW2
	dd WAZ_GLOWA_X
	
	db 0Bh
	dd TEMP_POROW2
	dd 2
	
	db 4
	dd TEMP_POROW
	dd TEMP_POROW2
	
	db 3
	dd TEMP_POROW
	dd PLANSZA
	
	db 11h
	dd TEMP_POROW
	dd WAZ_KIERUNEK
	
	db 1
	dd WPISANY_KIER
	dd 1


	; Oznaczona
	
	db 2
	dd CURSORX
	dd WAZ_GLOWA_X
	
	db 81h
	dd CURSORX
	dd KOLKO_WAZ_WYS
	
	db 2
	dd CURSORY
	dd WAZ_GLOWA_Y
	
	db 81h
	dd CURSORY
	dd KOLKO_WAZ_SZER
	
	; Rysujemy nowa glowe
	db 8Eh
	dd waz_kolko
	dd CURSORX
	dd CURSORY
	
	db 1
	dd TEMP_POROW
	dd 1
	
	; Jesli zebrano jedzonko to nie przesuwamy dupy
	db 12h
	dd snake_main_loop
	dd TEMP_POROW
	dd VAR_ZEBRANO_JEDZONKO
	
	; Przesuwamy dupe weza i ja wywalamy
	; Najpierw na planszy:
	db 2
	dd TEMP_POROW
	dd WAZ_DUPA_Y
	
	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH * 4 ; (mnozymy przez 4 bo mamy DWORDY a nie bajty)
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 2
	dd TEMP_POROW2
	dd WAZ_DUPA_X
	
	db 0Bh
	dd TEMP_POROW2
	dd 2
	
	db 4
	dd TEMP_POROW
	dd TEMP_POROW2
	
	db 3
	dd TEMP_POROW
	dd PLANSZA
	
	db 1
	dd TEMP_POROW2
	dd 0
	
	; Zapamietujemy kierunek dupy zeby wiedziec gdzie ja przesunac
	db 10h
	dd TEMP_POLE
	dd TEMP_POROW
	
	; Wywalamy dupe na planszy
	db 11h
	dd TEMP_POROW
	dd TEMP_POROW2


	; I z ekranu:
	db 2
	dd CURSORX
	dd WAZ_DUPA_X
	
	db 2
	dd CURSORY
	dd WAZ_DUPA_Y
	
	db 81h
	dd CURSORX
	dd KOLKO_WAZ_SZER
	
	db 81h
	dd CURSORY
	dd KOLKO_WAZ_WYS
	
	db 8Eh
	dd pustka
	dd CURSORX
	dd CURSORY
	; Wywalona
	
	db 2
	dd TEMP_POROW
	dd TEMP_POLE ; Zapamietana przed chwila przy wywalaniu
	
	db 1
	dd TEMP_MNOZ
	dd 4
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 3
	dd TEMP_POROW
	dd tablica_skokow_dupa
	
	db 10h
	dd TEMP_POROW
	dd TEMP_POROW
	
	db 0Dh
	dd TEMP_POROW
	
	tablica_skokow_dupa:
	dd 0
	dd 0
	dd snake_przesun_dupe_gora
	dd snake_przesun_dupe_dol
	dd snake_przesun_dupe_lewo
	dd snake_przesun_dupe_prawo
	
	snake_przesun_dupe_gora:
		db 84h
		dd WAZ_DUPA_Y
		dd 1
		
		db 0Eh
		dd po_przesunieciu_dupy
	snake_przesun_dupe_dol:
		db 3
		dd WAZ_DUPA_Y
		dd 1
	
		db 0Eh
		dd po_przesunieciu_dupy
	snake_przesun_dupe_lewo:
		db 84h
		dd WAZ_DUPA_X
		dd 1
	
		db 0Eh
		dd po_przesunieciu_dupy
	snake_przesun_dupe_prawo:
		db 3
		dd WAZ_DUPA_X
		dd 1
	
		db 0Eh
		dd po_przesunieciu_dupy
	
	po_przesunieciu_dupy:
	
	
	db 0Eh
	dd snake_main_loop
	
snake_lose:
db 1
dd 02002004h
dd 0

db 1
dd TEMP_POROW
dd 640*480*4

db 23h
dd 02006000h
dd 0
dd TEMP_POROW

db 1
dd CURSORX
dd 220

db 1
dd CURSORY
dd 220

db 1
dd SCR_KOLOR
dd 00FFFFFFh

db 96h
dd PUNKTY

db 86h
dd snake_gratulacje_str1

db 86h
dd ITOA_RETURN

db 86h
dd snake_gratulacje_str2

db 1
dd TEMP_SLEEP
dd 2000

db 99h
dd TEMP_SLEEP

db 0Eh
dd koniec_data_snake

snake_keyboard_handler:
db 2
dd SAVED_RET
dd 02000004h

db 1
dd TEMP_POROW
dd 0

db 12h
dd koniec_snake_keyboard
dd WPISANY_KIER
dd TEMP_POROW

db 1
dd TEMP_POROW
dd 273			; Szczauka w gore

db 12h
dd snake_gora_key
dd 02002008h
dd TEMP_POROW

db 1
dd TEMP_POROW
dd 274			; Szczauka w dol

db 12h
dd snake_dol_key
dd 02002008h
dd TEMP_POROW

db 1
dd TEMP_POROW
dd 275			; Szczauka w prawo

db 12h
dd snake_prawo_key
dd 02002008h
dd TEMP_POROW

db 1
dd TEMP_POROW
dd 276			; Szczauka w lewo

db 12h
dd snake_lewo_key
dd 02002008h
dd TEMP_POROW

db 0Eh
dd koniec_snake_keyboard

snake_gora_key:
	db 1
	dd TEMP_POROW
	dd 4
	
	db 13h
	dd koniec_snake_keyboard
	dd WAZ_KIERUNEK
	dd TEMP_POROW
	
	db 1
	dd WAZ_KIERUNEK
	dd KIERUNEK_GORA
	
	db 2
	dd TEMP_POROW
	dd WAZ_GLOWA_Y
	
	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH * 4
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 2
	dd TEMP_POROW2
	dd WAZ_GLOWA_X
	
	db 0Bh
	dd TEMP_POROW2
	dd 2
	
	db 4
	dd TEMP_POROW
	dd TEMP_POROW2
	
	db 3
	dd TEMP_POROW
	dd PLANSZA
	
	db 11h
	dd TEMP_POROW
	dd WAZ_KIERUNEK
	
	
	
	db 1
	dd WPISANY_KIER
	dd 0
	
	db 0Eh
	dd snake_keyboard_zmien_kierunek
snake_dol_key:
	db 1
	dd TEMP_POROW
	dd 4
	
	db 13h
	dd koniec_snake_keyboard
	dd WAZ_KIERUNEK
	dd TEMP_POROW
	
	db 1
	dd WAZ_KIERUNEK
	dd KIERUNEK_DOL

	db 1
	dd WPISANY_KIER
	dd 0
	
	db 0Eh
	dd snake_keyboard_zmien_kierunek
snake_lewo_key:
	db 1
	dd TEMP_POROW
	dd 3
	
	db 13h
	dd koniec_snake_keyboard
	dd TEMP_POROW
	dd WAZ_KIERUNEK
	
	db 1
	dd WAZ_KIERUNEK
	dd KIERUNEK_LEWO

	db 1
	dd WPISANY_KIER
	dd 0

	db 0Eh
	dd snake_keyboard_zmien_kierunek
snake_prawo_key:
	db 1
	dd TEMP_POROW
	dd 3
	
	db 13h
	dd koniec_snake_keyboard
	dd TEMP_POROW
	dd WAZ_KIERUNEK
	
	db 1
	dd WAZ_KIERUNEK
	dd KIERUNEK_PRAWO
	
	db 1
	dd WPISANY_KIER
	dd 0

	db 0Eh
	dd snake_keyboard_zmien_kierunek

snake_keyboard_zmien_kierunek:

	; Oznaczamy miejsce w ktorym znajduje sie nasza glowa na nowy kierunek
	db 2
	dd TEMP_POROW
	dd WAZ_GLOWA_Y
	
	db 1
	dd TEMP_MNOZ
	dd PLANSZA_WIDTH * 4
	
	db 81h
	dd TEMP_POROW
	dd TEMP_MNOZ
	
	db 2
	dd TEMP_POROW2
	dd WAZ_GLOWA_X
	
	db 0Bh
	dd TEMP_POROW2
	dd 2
	
	db 4
	dd TEMP_POROW
	dd TEMP_POROW2
	
	db 3
	dd TEMP_POROW
	dd PLANSZA
	
	db 11h
	dd TEMP_POROW
	dd WAZ_KIERUNEK
	
	db 1
	dd WPISANY_KIER
	dd 0

koniec_snake_keyboard:

db 15h

db 0Dh
dd SAVED_RET

; --------------------DANE----------------
waz_kolko:
incbin "snake/waz.raw"
jedzonko:
incbin "snake/jedzonko.raw"
pustka: dd 15
dd 15
 times 15*15*4 db 000h ; Tymczasowo, faktycznie bedziemy kopiowac z obrazka tla
snake_gratulacje_str1: db "Gratulacje, zdobyles ",0
snake_gratulacje_str2: db " punktow!",0

koniec_data_snake: